/*---------------------------------------------------------------------*/
/* --- STC AI Limited -------------------------------------------------*/
/* --- Web: www.STCAI.com ---------------------------------------------*/
/*---------------------------------------------------------------------*/

#include "stc.h"
#include "ES8156.h"

#define ES8156_WR	0x10
#define ES8156_RD	0x11

sbit	P_ES8156_SCL = P5^1;
sbit	P_ES8156_SDA = P5^0;

void	ES8156_Delay(void)
{
	u16	dly;
	dly = 8;		//ȡ1ӦSCL HΪ0.5us,LΪ1.5us,д.Ϊ˿ɿ,ȡ8
	while(--dly)	;
}

void ES8156_Start(void)               //start the I2C, SDA High-to-low when SCL is high
{
	P_ES8156_SDA = 1;	//SDA = 1;
	ES8156_Delay();
	P_ES8156_SCL = 1;	//SCL = 1;
	ES8156_Delay();
	ES8156_Delay();
	ES8156_Delay();
	ES8156_Delay();
	P_ES8156_SDA = 0;	//SDA = 0;
	ES8156_Delay();
	ES8156_Delay();
	ES8156_Delay();
	P_ES8156_SCL = 0;	//SCL = 0;
	ES8156_Delay();
}


void ES8156_Stop(void)					//STOP the I2C, SDA Low-to-high when SCL is high
{
	P_ES8156_SCL = 0;	//SCL = 0;
	ES8156_Delay();
	P_ES8156_SDA = 0;	//SDA = 0;
	ES8156_Delay();
	P_ES8156_SCL = 1;	//SCL = 1;
	ES8156_Delay();
	ES8156_Delay();
	ES8156_Delay();
	P_ES8156_SDA = 1;	//SDA = 1;
	ES8156_Delay();
}

u8 ES8156_Check_ACK(void)         //Check ACK, If status=0: right, if status=1:  error
{
	u8	status;
	P_ES8156_SDA = 1;	//SDA = 1;
	ES8156_Delay();
	P_ES8156_SCL = 1;	//SCL = 1;
	ES8156_Delay();
	status = 0;
	if(P_ES8156_SDA)
		status = 1;
	P_ES8156_SCL = 0;	//SCL = 0;
	ES8156_Delay();
	return	status;
}

/****************************/
void ES8156_WriteAbyte(u8 dat)		//write a byte to I2C
{
	u8 i;
	for(i=0; i<8; i++)
	{
		if(dat & 0x80)
			P_ES8156_SDA = 1;	//SDA = 1;
		else
			P_ES8156_SDA = 0;	//SDA = 0;
		ES8156_Delay();
		P_ES8156_SCL = 1;	//SCL = 1;
		dat <<= 1;
		ES8156_Delay();
		P_ES8156_SCL = 0;	//SCL = 0;
		ES8156_Delay();
	}
}

u8	ES8156_RegWrite(u8 RegAddr, u8 dat)	//0: ȷ, >0: 
{
	u8	status;

	status = 1;
	ES8156_Start();
	ES8156_WriteAbyte(ES8156_WR);		//device address + WR
	if(ES8156_Check_ACK() == 0)
	{
		ES8156_WriteAbyte(RegAddr);	//register address
		if(ES8156_Check_ACK() == 0)
		{
			ES8156_WriteAbyte(dat);	//data
			if(ES8156_Check_ACK() == 0)	//data
					status = 0;
		}
	}
	ES8156_Stop();
	return	status;
}

u8	ES8156_WriteCmd(u16 RegAddr, u16 dat)
{
	u8	status;

	status = 1;
	ES8156_Start();
	ES8156_WriteAbyte(ES8156_WR);		//device address + WR
	if(ES8156_Check_ACK() == 0)
	{
		dat = (RegAddr << 8) | dat;
		ES8156_WriteAbyte((u8)(dat >> 8));
		if(ES8156_Check_ACK() == 0)
		{
			ES8156_WriteAbyte((u8)dat);
			if(ES8156_Check_ACK() == 0)	status = 0;
		}
	}
	ES8156_Stop();
	return	status;
}

void ES8156_Reset(void)//ṩIISʱӺҪ
{
	P5n_standard(Pin1+Pin0);	//SDA SCLΪ׼˫
	P5PU = 0x02;
	
	ES8156_WriteCmd(0x00,0x1C);	
	ES8156_WriteCmd(0x00,0x01);//Slave  Mode		  
} 

void ES8156_DAC(void)
{
	ES8156_WriteCmd(0x02,(MCLK_SOURCE<<7) + (SCLK_INV<<4) +  (EQ7bandOn<<3) + 0x04 + MSMode_MasterSelOn);	
	ES8156_WriteCmd(0x13,0x00);
	if(DACHPModeOn == 0)//PALOUT,ڲ,ʡ
	{
		ES8156_WriteCmd(0x20,0x2A);
		ES8156_WriteCmd(0x21,0x3C);
		ES8156_WriteCmd(0x22,0x02);
		ES8156_WriteCmd(0x24,0x07);
		ES8156_WriteCmd(0x23,0x40+(0x30*VDDA_VOLTAGE));
	}
	if(DACHPModeOn == 1)//Ӷ,ڲ,ֶ֧
	{
		ES8156_WriteCmd(0x20,0x16);
		ES8156_WriteCmd(0x21,0x3F);
		ES8156_WriteCmd(0x22,0x0A);
		ES8156_WriteCmd(0x24,0x01);
		ES8156_WriteCmd(0x25,0x28);
		ES8156_WriteCmd(0x23,0xCA+(0x30*VDDA_VOLTAGE));
	}
	ES8156_WriteCmd(0x0A,0x01);
	ES8156_WriteCmd(0x0B,0x01);
	ES8156_WriteCmd(0x11,NORMAL_I2S + (Format_Len<<4));
	ES8156_WriteCmd(0x14,DAC_Volume);
	if(Ratio == 1536)//Ratio=MCLK/LRCK=153612M288/8K24M576/16K
	{
		ES8156_WriteCmd(0x01,0x26 - (0x03*EQ7bandOn));//1536 Ratio(MCLK/LRCK)
		ES8156_WriteCmd(0x09,0x00);//1536 Ratio(MCLK/LRCK)
	}
	if(Ratio == 1024)//Ratio=MCLK/LRCK=102412M288/12K24M576/24K
	{
		ES8156_WriteCmd(0x01,0x24 - (0x02*EQ7bandOn));//256 Ratio(MCLK/LRCK)
		ES8156_WriteCmd(0x09,0x00);//256 Ratio(MCLK/LRCK)										
	}
	if(Ratio == 768)//Ratio=MCLK/LRCK=76812M288/16K24M576/32K
	{
		ES8156_WriteCmd(0x01,0x23 + (0x40*EQ7bandOn));//768 Ratio(MCLK/LRCK)
		ES8156_WriteCmd(0x09,0x00);//768 Ratio(MCLK/LRCK)									
	}
	if(Ratio == 512)//Ratio=MCLK/LRCK=51212M288/24K24M576/48K
	{
		ES8156_WriteCmd(0x01,0x22 - (0x01*EQ7bandOn));//512 Ratio(MCLK/LRCK)	
		ES8156_WriteCmd(0x09,0x00);//512 Ratio(MCLK/LRCK)
	}
	if(Ratio == 400)//Ratio=MCLK/LRCK=40019M2/48K
	{	//DVDD3V3,1V8֧
		ES8156_WriteCmd(0x01,0x21 + (0x40*EQ7bandOn));//384 Ratio(MCLK/LRCK)
		ES8156_WriteCmd(0x09,0x00);//400 Ratio(MCLK/LRCK)
		ES8156_WriteCmd(0x10,0x64);//400 OSR
	}
	if(Ratio == 384)//Ratio=MCLK/LRCK=38412M288/32K6M144/16K
	{
		ES8156_WriteCmd(0x01,0x63 + (0x40*EQ7bandOn));//384 Ratio(MCLK/LRCK)
		ES8156_WriteCmd(0x09,0x00);//384 Ratio(MCLK/LRCK)
	}
	if(Ratio == 256)//Ratio=MCLK/LRCK=25612M288/48K
	{
		ES8156_WriteCmd(0x01,0x21 + (0x40*EQ7bandOn));//256 Ratio(MCLK/LRCK)
		ES8156_WriteCmd(0x09,0x00);//256 Ratio(MCLK/LRCK)
	}
	if(Ratio == 128)//Ratio=MCLK/LRCK=1286M144/48K
	{
		ES8156_WriteCmd(0x01,0x61 + (0x40*EQ7bandOn));//128 Ratio(MCLK/LRCK)
		ES8156_WriteCmd(0x09,0x00);//128 Ratio(MCLK/LRCK)
	}
	if(Ratio == 64)//Ratio=MCLK/LRCK=643M072/48K
	{
		ES8156_WriteCmd(0x01,0xA1);//64 Ratio(MCLK/LRCK)
		ES8156_WriteCmd(0x09,0x02);//64 Ratio(MCLK/LRCK)
	}
	
	ES8156_WriteCmd(0x03,(Ratio>>8));		//LRCK DIV
	ES8156_WriteCmd(0x04,(Ratio & 0xFF));	//LRCK DIV
	ES8156_WriteCmd(0x05,SCLK_DIV);			//SCLK DIV
	
	ES8156_WriteCmd(0x0D,0x14);
	ES8156_WriteCmd(0x18,0x00);
	ES8156_WriteCmd(0x08,0x3F);
	ES8156_WriteCmd(0x00,0x02);
	ES8156_WriteCmd(0x00,0x03);
}